Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/boundary.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -1463,4 +1836,8 @@
   if (InsertUnique.second) // if new point was not present before, increase counter
     PointsOnBoundaryCount++;
+  else {
+    delete(BPS[0]);
+    BPS[0] = NULL;
+  }
 }
 ;
@@ -1904,6 +2281,6 @@
   Vector CirclePlaneNormal; // normal vector defining the plane this circle lives in
   Vector SphereCenter;
-  Vector NewSphereCenter;	 // center of the sphere defined by the two points of BaseLine and the one of Candidate, first possibility
-  Vector OtherNewSphereCenter;	 // center of the sphere defined by the two points of BaseLine and the one of Candidate, second possibility
+  Vector NewSphereCenter;   // center of the sphere defined by the two points of BaseLine and the one of Candidate, first possibility
+  Vector OtherNewSphereCenter;   // center of the sphere defined by the two points of BaseLine and the one of Candidate, second possibility
   Vector NewNormalVector;   // normal vector of the Candidate's triangle
   Vector helper, OptCandidateCenter, OtherOptCandidateCenter;
@@ -1985,5 +2362,5 @@
 
                   if ((NewNormalVector.MakeNormalVector(&(BaseLine->endpoints[0]->node->x), &(BaseLine->endpoints[1]->node->x), &(Candidate->x)))
-                	&& (fabs(NewNormalVector.ScalarProduct(&NewNormalVector)) > HULLEPSILON)
+                  && (fabs(NewNormalVector.ScalarProduct(&NewNormalVector)) > HULLEPSILON)
                   ) {
                     helper.CopyVector(&NewNormalVector);
@@ -2072,6 +2449,6 @@
   //cout << Verbose(2) << "INFO: Sorting candidate list ..." << endl;
   if (candidates->size() > 1) {
-	  candidates->unique();
-	  candidates->sort(sortCandidates);
+    candidates->unique();
+    candidates->sort(sortCandidates);
   }
 
@@ -2080,8 +2457,8 @@
 
 struct Intersection {
-	Vector x1;
-	Vector x2;
-	Vector x3;
-	Vector x4;
+  Vector x1;
+  Vector x2;
+  Vector x3;
+  Vector x4;
 };
 
@@ -2093,27 +2470,27 @@
  */
 double MinIntersectDistance(const gsl_vector * x, void *params) {
-	double retval = 0;
-	struct Intersection *I = (struct Intersection *)params;
-	Vector intersection;
-	Vector SideA,SideB,HeightA, HeightB;
-	for (int i=0;i<NDIM;i++)
-		intersection.x[i] = gsl_vector_get(x, i);
-
-	SideA.CopyVector(&(I->x1));
-	SideA.SubtractVector(&I->x2);
-	HeightA.CopyVector(&intersection);
-	HeightA.SubtractVector(&I->x1);
-	HeightA.ProjectOntoPlane(&SideA);
-
-	SideB.CopyVector(&I->x3);
-	SideB.SubtractVector(&I->x4);
-	HeightB.CopyVector(&intersection);
-	HeightB.SubtractVector(&I->x3);
-	HeightB.ProjectOntoPlane(&SideB);
-
-	retval = HeightA.ScalarProduct(&HeightA) + HeightB.ScalarProduct(&HeightB);
-	//cout << Verbose(2) << "MinIntersectDistance called, result: " << retval << endl;
-
-	return retval;
+  double retval = 0;
+  struct Intersection *I = (struct Intersection *)params;
+  Vector intersection;
+  Vector SideA,SideB,HeightA, HeightB;
+  for (int i=0;i<NDIM;i++)
+    intersection.x[i] = gsl_vector_get(x, i);
+
+  SideA.CopyVector(&(I->x1));
+  SideA.SubtractVector(&I->x2);
+  HeightA.CopyVector(&intersection);
+  HeightA.SubtractVector(&I->x1);
+  HeightA.ProjectOntoPlane(&SideA);
+
+  SideB.CopyVector(&I->x3);
+  SideB.SubtractVector(&I->x4);
+  HeightB.CopyVector(&intersection);
+  HeightB.SubtractVector(&I->x3);
+  HeightB.ProjectOntoPlane(&SideB);
+
+  retval = HeightA.ScalarProduct(&HeightA) + HeightB.ScalarProduct(&HeightB);
+  //cout << Verbose(2) << "MinIntersectDistance called, result: " << retval << endl;
+
+  return retval;
 };
 
@@ -2132,11 +2509,11 @@
  */
 bool existsIntersection(Vector point1, Vector point2, Vector point3, Vector point4) {
-	bool result;
-
-	struct Intersection par;
-		par.x1.CopyVector(&point1);
-		par.x2.CopyVector(&point2);
-		par.x3.CopyVector(&point3);
-		par.x4.CopyVector(&point4);
+  bool result;
+
+  struct Intersection par;
+    par.x1.CopyVector(&point1);
+    par.x2.CopyVector(&point2);
+    par.x3.CopyVector(&point3);
+    par.x4.CopyVector(&point4);
 
     const gsl_multimin_fminimizer_type *T = gsl_multimin_fminimizer_nmsimplex;
@@ -2179,47 +2556,47 @@
 
         if (status == GSL_SUCCESS) {
-        	cout << Verbose(2) << "converged to minimum" <<  endl;
+          cout << Verbose(2) << "converged to minimum" <<  endl;
         }
     } while (status == GSL_CONTINUE && iter < 100);
 
     // check whether intersection is in between or not
-	Vector intersection, SideA, SideB, HeightA, HeightB;
-	double t1, t2;
-	for (int i = 0; i < NDIM; i++) {
-		intersection.x[i] = gsl_vector_get(s->x, i);
-	}
-
-	SideA.CopyVector(&par.x2);
-	SideA.SubtractVector(&par.x1);
-	HeightA.CopyVector(&intersection);
-	HeightA.SubtractVector(&par.x1);
-
-	t1 = HeightA.Projection(&SideA)/SideA.ScalarProduct(&SideA);
-
-	SideB.CopyVector(&par.x4);
-	SideB.SubtractVector(&par.x3);
-	HeightB.CopyVector(&intersection);
-	HeightB.SubtractVector(&par.x3);
-
-	t2 = HeightB.Projection(&SideB)/SideB.ScalarProduct(&SideB);
-
-	cout << Verbose(2) << "Intersection " << intersection << " is at "
-		<< t1 << " for (" << point1 << "," << point2 << ") and at "
-		<< t2 << " for (" << point3 << "," << point4 << "): ";
-
-	if (((t1 >= 0) && (t1 <= 1)) && ((t2 >= 0) && (t2 <= 1))) {
-		cout << "true intersection." << endl;
-		result = true;
-	} else {
-		cout << "intersection out of region of interest." << endl;
-		result = false;
-	}
-
-	// free minimizer stuff
+  Vector intersection, SideA, SideB, HeightA, HeightB;
+  double t1, t2;
+  for (int i = 0; i < NDIM; i++) {
+    intersection.x[i] = gsl_vector_get(s->x, i);
+  }
+
+  SideA.CopyVector(&par.x2);
+  SideA.SubtractVector(&par.x1);
+  HeightA.CopyVector(&intersection);
+  HeightA.SubtractVector(&par.x1);
+
+  t1 = HeightA.Projection(&SideA)/SideA.ScalarProduct(&SideA);
+
+  SideB.CopyVector(&par.x4);
+  SideB.SubtractVector(&par.x3);
+  HeightB.CopyVector(&intersection);
+  HeightB.SubtractVector(&par.x3);
+
+  t2 = HeightB.Projection(&SideB)/SideB.ScalarProduct(&SideB);
+
+  cout << Verbose(2) << "Intersection " << intersection << " is at "
+    << t1 << " for (" << point1 << "," << point2 << ") and at "
+    << t2 << " for (" << point3 << "," << point4 << "): ";
+
+  if (((t1 >= 0) && (t1 <= 1)) && ((t2 >= 0) && (t2 <= 1))) {
+    cout << "true intersection." << endl;
+    result = true;
+  } else {
+    cout << "intersection out of region of interest." << endl;
+    result = false;
+  }
+
+  // free minimizer stuff
     gsl_vector_free(x);
     gsl_vector_free(ss);
     gsl_multimin_fminimizer_free(s);
 
-	return result;
+  return result;
 }
 
@@ -2241,5 +2618,5 @@
   int N[NDIM], Nlower[NDIM], Nupper[NDIM];
 
-  if (LC->SetIndexToAtom(*a)) {  // get cell for the starting atom
+  if (LC->SetIndexToAtom(a)) {  // get cell for the starting atom
     for(int i=0;i<NDIM;i++) // store indices of this cell
       N[i] = LC->n[i];
@@ -2603,5 +2980,5 @@
   cout << Verbose(1) << "Third Points are ";
   for (CandidateList::iterator it = Opt_Candidates->begin(); it != Opt_Candidates->end(); ++it) {
-	  cout << " " << *(*it)->point;
+    cout << " " << *(*it)->point;
   }
   cout << endl;
@@ -2609,18 +2986,18 @@
   BoundaryLineSet *BaseRay = &Line;
   for (CandidateList::iterator it = Opt_Candidates->begin(); it != Opt_Candidates->end(); ++it) {
-	  cout << Verbose(1) << " Third point candidate is " << *(*it)->point
-		<< " with circumsphere's center at " << (*it)->OptCenter << "." << endl;
-	  cout << Verbose(1) << " Baseline is " << *BaseRay << endl;
-
-	  // check whether all edges of the new triangle still have space for one more triangle (i.e. TriangleCount <2)
-	  atom *AtomCandidates[3];
-	  AtomCandidates[0] = (*it)->point;
-	  AtomCandidates[1] = BaseRay->endpoints[0]->node;
-	  AtomCandidates[2] = BaseRay->endpoints[1]->node;
-	  int existentTrianglesCount = CheckPresenceOfTriangle(out, AtomCandidates);
-
-	  BTS = NULL;
-	  // If there is no triangle, add it regularly.
-	  if (existentTrianglesCount == 0) {
+    cout << Verbose(1) << " Third point candidate is " << *(*it)->point
+    << " with circumsphere's center at " << (*it)->OptCenter << "." << endl;
+    cout << Verbose(1) << " Baseline is " << *BaseRay << endl;
+
+    // check whether all edges of the new triangle still have space for one more triangle (i.e. TriangleCount <2)
+    atom *AtomCandidates[3];
+    AtomCandidates[0] = (*it)->point;
+    AtomCandidates[1] = BaseRay->endpoints[0]->node;
+    AtomCandidates[2] = BaseRay->endpoints[1]->node;
+    int existentTrianglesCount = CheckPresenceOfTriangle(out, AtomCandidates);
+
+    BTS = NULL;
+    // If there is no triangle, add it regularly.
+    if (existentTrianglesCount == 0) {
       AddTrianglePoint((*it)->point, 0);
       AddTrianglePoint(BaseRay->endpoints[0]->node, 1);
@@ -2640,5 +3017,5 @@
         << " for this triangle ... " << endl;
       //cout << Verbose(1) << "We have "<< TrianglesOnBoundaryCount << " for line " << *BaseRay << "." << endl;
-	  } else if (existentTrianglesCount == 1) { // If there is a planar region within the structure, we need this triangle a second time.
+    } else if (existentTrianglesCount == 1) { // If there is a planar region within the structure, we need this triangle a second time.
         AddTrianglePoint((*it)->point, 0);
         AddTrianglePoint(BaseRay->endpoints[0]->node, 1);
@@ -2679,5 +3056,5 @@
     }
 
-	  if ((result) && (existentTrianglesCount < 2) && (DoSingleStepOutput && (TrianglesOnBoundaryCount % 1 == 0))) { // if we have a new triangle and want to output each new triangle configuration
+    if ((result) && (existentTrianglesCount < 2) && (DoSingleStepOutput && (TrianglesOnBoundaryCount % 1 == 0))) { // if we have a new triangle and want to output each new triangle configuration
       sprintf(NumberName, "-%04d-%s_%s_%s", TriangleFilesWritten, BTS->endpoints[0]->node->Name, BTS->endpoints[1]->node->Name, BTS->endpoints[2]->node->Name);
       if (DoTecplotOutput) {
@@ -2711,5 +3088,5 @@
         (*it)->OptCenter.AddVector(&helper);
         Vector *center = mol->DetermineCenterOfAll(out);
-        (*it)->OptCenter.AddVector(center);
+        (*it)->OptCenter.SubtractVector(center);
         delete(center);
         // and add to file plus translucency object
@@ -2726,8 +3103,8 @@
       if (DoTecplotOutput || DoRaster3DOutput)
         TriangleFilesWritten++;
-	  }
+    }
 
     // set baseline to new ray from ref point (here endpoints[0]->node) to current candidate (here (*it)->point))
-	  BaseRay = BLS[0];
+    BaseRay = BLS[0];
   }
 
@@ -2760,30 +3137,30 @@
 
   // create normal in-plane vector to cope with acos() non-uniqueness on [0,2pi] (note that is pointing in the "right" direction already, hence ">0" test!)
-	helper.CopyVector(&(candidate1->BaseLine->endpoints[0]->node->x));
-	helper.SubtractVector(&(candidate1->point->x));
-	OrthogonalVector.CopyVector(&helper);
-	helper.VectorProduct(&BaseLineVector);
-	OrthogonalVector.SubtractVector(&helper);
-	OrthogonalVector.Normalize();
+  helper.CopyVector(&(candidate1->BaseLine->endpoints[0]->node->x));
+  helper.SubtractVector(&(candidate1->point->x));
+  OrthogonalVector.CopyVector(&helper);
+  helper.VectorProduct(&BaseLineVector);
+  OrthogonalVector.SubtractVector(&helper);
+  OrthogonalVector.Normalize();
 
   // calculate both angles and correct with in-plane vector
-	helper.CopyVector(&(candidate1->point->x));
-	helper.SubtractVector(&(candidate1->BaseLine->endpoints[0]->node->x));
-	double phi = BaseLineVector.Angle(&helper);
+  helper.CopyVector(&(candidate1->point->x));
+  helper.SubtractVector(&(candidate1->BaseLine->endpoints[0]->node->x));
+  double phi = BaseLineVector.Angle(&helper);
   if (OrthogonalVector.ScalarProduct(&helper) > 0) {
     phi = 2.*M_PI - phi;
   }
   helper.CopyVector(&(candidate2->point->x));
-	helper.SubtractVector(&(candidate1->BaseLine->endpoints[0]->node->x));
-	double psi = BaseLineVector.Angle(&helper);
+  helper.SubtractVector(&(candidate1->BaseLine->endpoints[0]->node->x));
+  double psi = BaseLineVector.Angle(&helper);
   if (OrthogonalVector.ScalarProduct(&helper) > 0) {
-		psi = 2.*M_PI - psi;
-	}
-
-	cout << Verbose(2) << *candidate1->point << " has angle " << phi << endl;
-	cout << Verbose(2) << *candidate2->point << " has angle " << psi << endl;
-
-	// return comparison
-	return phi < psi;
+    psi = 2.*M_PI - psi;
+  }
+
+  cout << Verbose(2) << *candidate1->point << " has angle " << phi << endl;
+  cout << Verbose(2) << *candidate2->point << " has angle " << psi << endl;
+
+  // return comparison
+  return phi < psi;
 }
 
@@ -3090,4 +3467,5 @@
  * \param *mol molecule structure with Atom's and Bond's
  * \param *Tess Tesselation filled with points, lines and triangles on boundary on return
+ * \param *LCList atoms in LinkedCell list
  * \param *filename filename prefix for output of vertex data
  * \para RADIUS radius of the virtual sphere
@@ -3137,5 +3515,5 @@
     }
   }
-  if (1) { //failflag) {
+  if (filename != 0) {
     *out << Verbose(1) << "Writing final tecplot file\n";
     if (DoTecplotOutput) {
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/boundary.hpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -54,4 +54,7 @@
 
     void AddTriangle(class BoundaryTriangleSet *triangle);
+    bool IsConnectedTo(class BoundaryLineSet *line);
+    bool ContainsBoundaryPoint(class BoundaryPointSet *point);
+    bool CheckConvexityCriterion(ofstream *out);
 
     class BoundaryPointSet *endpoints[2];
@@ -68,4 +71,7 @@
 
     void GetNormalVector(Vector &NormalVector);
+    bool GetIntersectionInsideTriangle(ofstream *out, Vector *MolCenter, Vector *x, Vector *Intersection);
+    bool ContainsBoundaryLine(class BoundaryLineSet *line);
+    bool ContainsBoundaryPoint(class BoundaryPointSet *point);
 
     class BoundaryPointSet *endpoints[3];
@@ -78,10 +84,10 @@
 class CandidateForTesselation {
   public :
-	CandidateForTesselation(atom* candidate, BoundaryLineSet* currentBaseLine, Vector OptCandidateCenter, Vector OtherOptCandidateCenter);
-	~CandidateForTesselation();
-	atom *point;
-	BoundaryLineSet *BaseLine;
-	Vector OptCenter;
-	Vector OtherOptCenter;
+  CandidateForTesselation(atom* candidate, BoundaryLineSet* currentBaseLine, Vector OptCandidateCenter, Vector OtherOptCandidateCenter);
+  ~CandidateForTesselation();
+  atom *point;
+  BoundaryLineSet *BaseLine;
+  Vector OptCenter;
+  Vector OtherOptCenter;
 };
 
@@ -93,5 +99,5 @@
     ~Tesselation();
 
-    void TesselateOnBoundary(ofstream *out, config *configuration, molecule *mol);
+    void TesselateOnBoundary(ofstream *out, molecule *mol);
     void GuessStartingTriangle(ofstream *out);
     void AddPoint(atom * Walker);
@@ -104,4 +110,8 @@
     int CheckPresenceOfTriangle(ofstream *out, atom *Candidates[3]);
     void Find_next_suitable_point_via_Angle_of_Sphere(atom* a, atom* b, atom* c, atom* Candidate, atom* Parent, int RecursionLevel, Vector *Chord, Vector *direction1, Vector *OldNormal, Vector ReferencePoint, atom*& Opt_Candidate, double *Storage, const double RADIUS, molecule* mol);
+    class BoundaryTriangleSet * FindClosestTriangleToPoint(ofstream *out, Vector *x);
+    bool IsInside(Vector *pointer);
+    bool InsertStraddlingPoints(ofstream *out, molecule *mol);
+    bool CorrectConcaveBaselines(ofstream *out);
     list<atom*> *getClosestConnectedAtoms(atom* Atom, atom* AtomToCheck);
     list<BoundaryTriangleSet*> *FindTriangles(atom* TrianglePoints[3]);
@@ -126,7 +136,9 @@
 
 
-double VolumeOfConvexEnvelope(ofstream *out, const char *filename, config *configuration, Boundaries *BoundaryPoints, molecule *mol);
+double VolumeOfConvexEnvelope(ofstream *out, class Tesselation *TesselStruct, class config *configuration);
 double * GetDiametersOfCluster(ofstream *out, Boundaries *BoundaryPtr, molecule *mol, bool IsAngstroem);
 void PrepareClustersinWater(ofstream *out, config *configuration, molecule *mol, double ClusterVolume, double celldensity);
+molecule * FillBoxWithMolecule(ofstream *out, MoleculeListClass *List, molecule *filler, config &configuration, double distance[NDIM], double RandAtomDisplacement, double RandMolDisplacement, bool DoRandomRotation);
+void Find_convex_border(ofstream *out, molecule* mol, class Tesselation *&TesselStruct, class LinkedCell *LCList, const char *filename);
 void Find_non_convex_border(ofstream *out, molecule* mol, class Tesselation *T, class LinkedCell *LC, const char *tempbasename, const double RADIUS);
 void Find_next_suitable_point(class BoundaryTriangleSet *BaseTriangle, class BoundaryLineSet *BaseLine, atom*& OptCandidate, Vector *OptCandidateCenter, double *ShortestAngle, const double RADIUS, LinkedCell *LC);
